| Home | Libraries | People | FAQ | More

#### posix::basic_descriptor::lowest_layer_type

A `posix::basic_descriptor` is always the lowest layer.

    typedef basic_descriptor< DescriptorService > lowest_layer_type;

###### Types

Name | Description
--- | ---
bytes_readable | IO control command to get the amount of data that can be read without blocking.
implementation_type | The underlying implementation type of I/O object.
lowest_layer_type | A basic_descriptor is always the lowest layer.
native_handle_type | The native representation of a descriptor.
native_type | (Deprecated: Use native_handle_type.) The native representation of a descriptor.
non_blocking_io | (Deprecated: Use non_blocking().) IO control command to set the blocking mode of the descriptor.
service_type | The type of the service that will be used to provide I/O operations.

###### Member Functions

Name | Description
--- | ---
assign | Assign an existing native descriptor to the descriptor.
basic_descriptor | Construct a basic_descriptor without opening it. Construct a basic_descriptor on an existing native descriptor. Move-construct a basic_descriptor from another.
cancel | Cancel all asynchronous operations associated with the descriptor.
close | Close the descriptor.
get_io_service | Get the io_service associated with the object.
io_control | Perform an IO control command on the descriptor.
is_open | Determine whether the descriptor is open.
lowest_layer | Get a reference to the lowest layer. Get a const reference to the lowest layer.
native | (Deprecated: Use native_handle().) Get the native descriptor representation.
native_handle | Get the native descriptor representation.
native_non_blocking | Gets the non-blocking mode of the native descriptor implementation. Sets the non-blocking mode of the native descriptor implementation.
non_blocking | Gets the non-blocking mode of the descriptor. Sets the non-blocking mode of the descriptor.
operator= | Move-assign a basic_descriptor from another.
release | Release ownership of the native descriptor implementation.

###### Protected Member Functions

Name | Description
--- | ---
get_implementation | Get the underlying implementation of the I/O object.
get_service | Get the service associated with the I/O object.
~basic_descriptor | Protected destructor to prevent deletion through this type.

###### Protected Data Members

Name | Description
--- | ---
implementation | (Deprecated: Use get_implementation().) The underlying implementation of the I/O object.
service | (Deprecated: Use get_service().) The service associated with the I/O object.

The `posix::basic_descriptor` class template provides the ability to wrap a POSIX descriptor.

###### Thread Safety

Distinct objects: Safe.

Shared objects: Unsafe.

###### Requirements

Header: `boost/asio/posix/basic_descriptor.hpp`

Convenience header: `boost/asio.hpp`